class Effect{
  World wld;
  boolean destroyed;
  
  Effect(){
    destroyed=false;
  }
  
  Effect(World _wld){
    wld=_wld;
  }
  
  void act(){
  }
  
  void drawEffect(){
  }
  
}

class EffectBombing extends Effect{
  int quantity;
  int error;
  Weapon weapon;
  
  EffectBombing(World _wld, int _quantity, int _error){
    wld=_wld;
    quantity=_quantity;
    error=_error;
    weapon = new Weapon(wld);
  }
  
  // Plays the effect. When returns true, the effect is removed from the list.
  void act(){
    int x,y;
    int i=0;
    int j=0;
    while (i<quantity && j<wld.initPop){
      if (wld.beings[j] instanceof Zombie) {
        x=wld.beings[j].xpos+(int) random(error)-error/2;
        y=wld.beings[j].ypos+(int) random(error)-error/2;
        weapon.fire(x,y);
        i++;
        j++;
      }
      else j++;
    }
    if (j== wld.initPop) destroyed=true;
  }
}
