/*
Todo :

04/12/2012 :
------------
- Screen and mission now display points awarded for mission completion


Things to do to finish version :
--------------------------------
- Color 
-- choose new color sheme
- Mission
-- Propose different missions

Remarks :
-------------------
- In strategy, default does not reset custom list
- In custom list, should not be able to deselect weapon required for other selected weapon (or should deselect everyother)
- In action, should not be allowed to select twice the same weapon
- Maybe consider allowing custom list in action ?
- Pause button highlight in panels
- some work on colors and general look... So far, it really looks ugly.
- Warning : could write a specific description of what triggered the warning


Optimisation :
--------------
- Profiling
-- This is the first step : knowing where time is being spent
VisualVM should allow to do that : http://visualvm.java.net/profiler.html

- Graph
-- ArrayList.size() is efficient enough (does not calculate again 
the value). But I should avoid calling the function again and 
again in the looping condition
-- General review of efficiency
-- Should the graph be drawn every tick ?

- Data
-- The way it is done now :
--- Game initialisation : create the various data fields.
--- Every turn : when weapon kills, is stored
--- Every turn : number of each class is computed then stored (rem : could be improved)
--- When being changes status, remembers what it was, and what killed it (saved in being)

-- Reasons for storing data :
--- End of game. Conditions on number of zombies or being. Present system is sufficient
--- Flavour text at the end of the game. From number of killed people... Close to be sufficient. Could be improved :
---- Number of killed per weapon (comment such as bombong artist,...)
---- Number of infected
--- Beings feat : recalls which being have behaved extraordinally (who killed the most zombies,...)
--- Weapons facts : recalls how many times a weapon has been used, and people it killed.
--- Graph : displays story line of different data.

-- Data to store and places to save that :
--- Being specific stats : in beings. 
---- Storyline (store events with date)
---- Synthetic data (total number of kills) (computed when storyline event created)
---- latest status (same as now ->what killed them, and previous type)
---- Fields for synthetic values adapt (new can be created when being changes type)
Allows to select exceptional beings, display their history, display info on map
--- Weapon specific data : in weapons ?
---- Number of time fired
---- Number of being killed/transformed/impacted
-> for devices, and things done by beings (soldier and zombies), need to link to weapon.
---- Storyline : give these values with date + synthetic
---- Total for weapons calculated
--- General population data
---- computed every turn (or few turns)
---- stores general data about the different population total and killed

- Mission :
*- Stores initial human

-- Event : known / hidden / random 
*-- Add zombies (?) (initial event)
--- immigrants (zombies / humans / soldier)
--- Wind (zombie move toward one direction)
--- Time : Bomb all zombies, score on number of surving humans (but dead by support don't count in score)
-> winning tested after event.

-- Ending conditions. When met, pauses the game display score, then proposes to continue.
*-- Zombies : All dead -> Win 
(--- Zombies : Number escaped -> loose (all map bombed) -> pause, then propose to continue)
*-- Human : All human dead -> loose 
*-- Human : number dead -> loose 
*-- Human : Number of human killed by player -> loose 
(--- Human : Number human saved -> win (bomb zombies))
(--- VIP : Number of Vip killed -> loose (Bomb zombies))
(--- VIP : Number of Vip saved -> win )


-- Score -> Allways same way to count
--- number human alive (2 pt par humain)
--- number human killed (-10 pt par humain) 
--- number zombies alive (-200 pour premier, puis augmentation diminue)
--- number of zombies killed (1 pt)
--- (number zombies escaped) (-400 pour premier, puis diminue)
--- (number human saved) (5 pt par humain)

-- Award :
(later)

Heat map (zombie / human location):
----------
Map to give direction for closer zombies / humans
-> possibility is spread smell from human with smaller increment every step (expensive).
-> Barycentre zombie par rapport position soldat. Mais pas de pathfinding.
-> Mix between spreading smell, over small area / updated every n turn for every being (not too often) for short distance + 
-> or communication between being (no path finding).

Structure :
-----------

- 


UI :
-----

- Navigation :
-- Screens :
--- First Screen
---- Game name (+ animation ?)
---- Select game style
----- Options
      - Scale (slider)
      - Size
        Slider for Width and Heigth. With max corresponding
        to screen
      - Human density (slider)
      - Zombie density (Z per human, or Z per square pixel ?)
      - Default button
      - Back to main screen
----- Help (?)

- Option Screen
-- When ? when starting, when pressing a key, when clicking,...
-- Can select differnt things to display at the bottom of the 
   screen (graph, ...)

- When paused, proposes different display mode
-- death reason (color code)
-- death density (number of zombies on one pixel)
-- humans (+ belief ?)
-- zombies (+ age)
-- Ammo
-- Devices

- No special effect layer (no sfx)


Game :
------

- Weapons :
-- Examples :
--- Foam :
    Expenses in wall
    Only grows on empty tiles (kills people). Drops objects at
    the limit, expense on empty, die when surrounded. Number 
    of objects to be placed controlled by central object
--- Dig :
    Place 2 objects. A rectangle is built between both. 
    Surface area is the same
--- Build :
    Same as dig, except that it builds (dirt, concrete)
--- Corridor :
    Same as dig, except that it builds a corridor (surrounded 
    with concrete
--- Paratroopers
    Click + Being
    Drops soldiers (instead of training people)
--- Rambo
    Click + Being
    Drops of tough soldier
    Large field of vision (everything in front of him), 
    but limited distance (5 ?). Moves forward if further than 5.
    Backward if closer than 4.
--- Information (changes the behaviour in an area)
    Click
    Reduces Panick
--- Path
    First, attracts people, then sends to second (is there a 
    chance for people to get confused and forget ?)
--- Take off
    Collects people in area (maybe coupled with attracktor)
--- Troop transport
    Collects troops (soldiers,...) and possibility once loaded
    to transport them to any other place of the map (create
    new option in weapons list)
--- Vaccin
    Click (area)
    Instead of turning into zombies, vaccinated people will
    just die
    Different type of vaccin -> when bitten, can turn into dead or
    other type of zombie (sleeping, bioweapon,...)
    
--- Doctor
    Click Being (chance of beings in area to be turned into 
    doctor)
    Move toward other humans (soldiers,...) to vaccinate them
    
--- Diagnostic
    Device that lets you know health level of humans nearby (displays specific color, instead basic type)
   
-- Disater
--- Infection : people infecting each other and then turning
    into zombies. To investigated(?) (could drop a dead body,
    that will rise again. Information, might teacj people to 
    butcher those fresh corpses.)
    Maybe also add behaviour of poeple killing each other even
    if not sick.

-- Somehow allowing user weapons customisation ? (adding effects
and damages to each other).
--- Either through parameters
--- Or through modules, combined together
--- need to create interface for that

- Data
-- save and display more data : max killed humans, max shot zombies,... 
-- Weapon like system, that gives stat in an area when clicked. 
  (Problem : how to display area selected without layers ?

- Behaviour
-- Maybe change color so only one or 2 parameters to recognize, and third to store some data 
(such as heading)
-- Investigating flocking. Might be tough there 
  (idea : different color depending on direction)
-- Slightly different than flocking, but have remote zombies attacking where survivors are 
(Should it be all zombies going toward closed humans, or a huge group moving being formed once a while ?)
-- Causalties if touched by panic, 
-- might also alter sensibility to attractors / repulsors
-- Investigating path finding for some weapons/beings

- Being history
-- Separate module storing stat and beings history (before and during game)
-- Being created with past (first name, surname, relatives, neighbours, job, age)
-- Remember if interaction with relative
-- Question how to iniate that cleverly ?
-> place all beings, then create story. (can choose people nearby)
-> create one after the other (risk of not spreading people evenly in town)
-> Simulate life year per year or decade per decade. But tough to control the xact numer in the end. 
Can check at some times and send immigrants / have emigrants. (create model that defines how many of each class I should have
every year/decade.
Check that website for first names/age :
http://www.ssa.gov/OACT/babynames/decades/index.html
http://www.prenoms.com/v2/services-prenom/top-des-prenoms.asp?theme=msn&year=
http://names.mongabay.com/most_common_surnames.htm
http://surnames.behindthename.com/top/lists/1000frs2005.php
http://www.insee.fr/fr/themes/tableau.asp?reg_id=0&ref_id=NATTEF02236

- Beings structure
-- Maybe devide being into modules, so easier to try different combination of zombies
-> see java interface

- Alternate Zombies :
-- Eat people (kill them) instead of changing them into zombies
--- Some dead might turn into zombie later (maybe usefull to chop them down)
--- Or dead might infect people, who then might turn into zombies
-- Mobs, or detection of living from far way ?
-- Possibility of evolution ?
--- Change infection type (target, kill/infect ratio, 
-- Infection transmitted by humans contact or not ?
--- Die, seems to die then turn into zombie, turn into zombie straight away ?
--> might need to think about zombie/diversity soon

- Other People type :
-- injured. They move slowly. Zombies feed on them (but can they turn into zombies ?)
Could be rescued by survivor ?

- UI :
-- Possibility to create scenario (parameters from start, with a bit of text)
-- Possibility to have scenario follow each other ? or meta game ?
-- Possibility to have alternative skin (multiculutre, or love spreading instead of zombies)
-- Language selection

Info position :
618-10 : 608 -> 76
138-10 = 128 -> 8,5

*/
